---
import BasicLayout from "@layouts/Basic.astro";
import Search from "@components/Search.jsx";
import path from "node:path";
import readTextFile from "read-text-file";
import "@styles/pesquisar.css";
import { replaceSpecialCharacters } from "@utils/replaceSpecialCharacters";
import { nhost } from "@utils/NhostClient";

// The content for page metadata & Open Graph metadata:
const canonicalURL = new URL(Astro.url.pathname, Astro.site);
const metaTitle = "Pesquisar";
const metaDescription = "Pesquise no conteúdo do site.";
const metaCanonicalURL = canonicalURL.href;
const metaType = "website";
const metaImage =
  canonicalURL.origin + "/images/Rembrandt_-_The_Philosopher_in_Meditation.jpg";

// Let's create the index that we'll be used by our search engine:
// - First we get the philosophers and the concepts from our database:
const philosophersResponse = await nhost.graphql.request(`
	query {
		people {
			name
			slug
		}
	}
`);
const conceptsResponse = await nhost.graphql.request(`
	query {
		concepts {
			title
			slug
		}
	}
`);
// - Now let's create functions that for each philosopher and each concept we get their texts from the local Markdown files and create their documents for the index:
// - We use readTextFile (https://github.com/matgr1/read-text-file) because it's enough to just get the files contents, we don't need to parse it.
const getPhilosophers = (response) => {
  const philosophers = response.data.people.map((person) => {
    const philosopherMarkdownPath = path.resolve(
      `src/content/people/${person.slug}.md`
    );
    var text = readTextFile.readSync(philosopherMarkdownPath);
    return {
      reference: person.name + "|filosofo/" + person.slug,
      title: replaceSpecialCharacters(person.name),
      text: replaceSpecialCharacters(text),
    };
  });
  return philosophers;
};
const getConcepts = (response) => {
  const concepts = response.data.concepts.map((concept) => {
    const conceptMarkdownPath = path.resolve(
      `src/content/concepts/${concept.slug}.md`
    );
    var text = readTextFile.readSync(conceptMarkdownPath);
    return {
      reference: concept.title + "|conceito/" + concept.slug,
      title: replaceSpecialCharacters(concept.title),
      text: replaceSpecialCharacters(text),
    };
  });
  return concepts;
};

// - Now run the functions and merge the two arrays, to send it to our React Search component:
const philosophers = getPhilosophers(philosophersResponse);
const concepts = getConcepts(conceptsResponse);
const documents = philosophers.concat(concepts);
---

<script is:inline src="/scripts/platform.js"></script>
<script is:inline src="/scripts/checkBrowserCompatibility.js"></script>
<script is:inline>
  // Hiding the search on old browsers (Svelte integration on Astro doesn't work on them):
  // https://github.com/bestiejs/platform.js
  // https://caniuse.com/mdn-javascript_operators_optional_chaining
  window.onload = function () {
    // console.log(checkBrowserCompatibility);
    if (!checkBrowserCompatibility("frameworkIntegration", platform)) {
      document.getElementById("form").style.display = "none";
      document.getElementById("formUnavailable").style.display = "block";
    }
  };
</script>

<BasicLayout
  metaTitle={metaTitle}
  metaDescription={metaDescription}
  metaCanonicalURL={metaCanonicalURL}
  metaType={metaType}
  metaImage={metaImage}
>
  <h1>Pesquisar</h1>

  <div id="form">
    <Search documents={documents} client:load />
  </div>
  <div id="formUnavailable" style="display:none;">
    <p>
      Esta funcionalidade está disponível somente em browsers mais modernos.
    </p>
  </div>
</BasicLayout>
